// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: RealPileupCorrector
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: RealPileupCorrector.h,v 1.1.1.1 2004/02/09 14:54:12 eojero Exp $

#ifndef RealPileupCorrector_H
#define RealPileupCorrector_H

// General classes

#include <iostream>

// SAS-specific classes

// General utility functions
#include "Tracer.h"

// Local classes
#include "PileupCorrector.h"
#include "PatternData.h"

// ===========================================================================

// class RealPileupCorrector

// True implementation of pile-up.

// ===========================================================================

class RealPileupCorrector : public PileupCorrector
{
public:

  //  Constructors 
  RealPileupCorrector( const PatternData &   patternData) :
    _patternData(patternData)
    {
      PROC;
      ENDPROC;
    };

  //  Destructors 
  ~RealPileupCorrector(){};

  double correction( double                     energy,
		     double                     pixelFlux ) const
    {
      PROC;
      RETURN _patternData.fluxAttenuation( energy, 
					   pixelFlux);
    }

private:

  const PatternData  & _patternData;
};
#endif
